#include-once
;Hide/UnHide Function
Func psi_Hide($psi_File, $psi_Action)
	select
		case $psi_Action="hide" ;if action is hide execute
			FileSetAttrib($psi_File, "+SH") ;Hide chosen file
		case $psi_Action="unhide" ;if action is unhide execute
			FileSetAttrib($psi_File, "-SH") ;UnHide chosen file
	EndSelect
EndFunc ;==>psi_Hide()



#cs
=========================================================================================
Function Reference
psi_LoadList
--------------------------------------------------------------------------------

Loads a set of ListViewItems into a ListView box from a file


#Include <PsiberneticUDF.au3>
psi_loadlist ( $psi_Path, $psi_ListViewCTRL )

Parameters

$psi_Path		Indicates path of log 

$psi_ListViewCTRL		Indicates the ID of the ListView CTRL the items will be placed into

Return Value

Success: Returns the global array $psi_ListViewItems[] which contains the control IDs of each item.
Failure: Returns program run-time error. 

 

Remarks

This function will read from the file indicated, each line is considered an entry.


 

Related

psi_AddListItem, psi_RemoveListItem
=========================================================================================
#ce
func psi_LoadList($psi_Path, $psi_ListViewCTRL)	
	$psi_FilesContainer=FileOpen($psi_Path,0) ;Open the log
	$psi_logEntries=_FileCountLines($psi_Path) ;Count the entries in the log 
	Dim $psi_FileEntry[1] ;Set the log importing array (integer indexed)
	
	$psi_ImportIndex=0 ;set the counter at 0
	while $psi_ImportIndex < $psi_LogEntries ;Log import loop beginning
		$psi_ImportIndex=$psi_ImportIndex+1 ;Increase counter
		_ArrayAdd($psi_FileEntry, FileReadLine($psi_FilesContainer, $psi_ImportIndex)) ;import an entry from the log into $psi_FileEntry[]
	WEnd ;Log import loop ending
	
	FileClose($psi_FilesContainer) ;Close the log
	
	Global $psi_ListViewItems[1] ;set the array containing the handles of the ListView Items (integer indexed)
	Global $psi_ImportIndex
	$psi_ImportIndex=0 ;set the counter at 0
	While $psi_ImportIndex < $psi_LogEntries ;Item add loop beginning
		$psi_ImportIndex=$psi_ImportIndex+1 ;Increase counter
		_ArrayAdd($psi_ListViewItems, GUICtrlCreateListViewItem($psi_FileEntry[$psi_ImportIndex], $psi_ListViewCTRL)) ;addListView entry to the specified ListView CTRL
	Wend ;Item add loop ending
	return 
endfunc ;==>psi_LoadList()



;===============================================================================
;
; Function Name:    psi_PathManipulate ( $psi_PathToEval, $psi_Action )
; Description:      Retrieve the filename or path from a file or folder path
; Parameter(s):     $psi_PathToEval  -The path to retrieve the filename from
;                   $psi_Action  -Retrieve filename or path   correct values: F or P
; Requirement(s):   #include <PsiberneticUDF.au3>
; Return Value(s):  On Success - Returns the filename
;                   On Failure - Returns N/A as filename
; @ERROR = 1        Not a file path
; @ERROR = 2        Not a valid path
; Author(s):        Psibernetic
;
;===============================================================================
func psi_PathManipulate($psi_PathToEval, $psi_Action)
	Select
		case StringInStr($psi_PathToEval, ".")=0
			SetError(1)
			$psi_Filename="N/A"
			$psi_Path=$psi_PathToEval
			select
				case StringUpper($psi_Action)="F"
					Return $psi_Filename
				case StringUpper($psi_Action)="P"
					Return $psi_Path
			EndSelect
		case StringInStr($psi_PathToEval, "\")=0
			SetError(2)
			$psi_Filename="N/A"
			$psi_Path="N/A"
			Return $psi_Filename
			Return $psi_Path
			select
				case StringUpper($psi_Action)="F"
					Return $psi_Filename
				case StringUpper($psi_Action)="P"
					Return $psi_Path
			EndSelect
		case Else
			$psi_Filename=""
			While StringRight($psi_PathToEval,1)<>"\"
				$psi_Filename=StringRight($psi_PathToEval,1) & $psi_Filename
				$psi_PathToEval=StringLeft($psi_PathToEval, (StringLen($psi_PathToEval)-1))
			WEnd
			$psi_Path=$psi_PathToEval
			select
				case StringUpper($psi_Action)="F"
					Return $psi_Filename
				case StringUpper($psi_Action)="P"
					Return $psi_Path
			EndSelect
	EndSelect ;==>psi_PathManipulate()

EndFunc



func psi_AddListItem($psi_Path, $psi_Data, $psi_ListViewCTRL)
	FileWriteLine($psi_Path, $psi_Data) ;Add the entry
	_ArrayAdd($psi_ListViewItems, GUICtrlCreateListViewItem($psi_Data, $psi_ListViewCTRL))
	Global $psi_ImportIndex
	$psi_ImportIndex=$psi_ImportIndex+1
EndFunc ;==>psi_AddListItem()


func psi_RemoveListItem($psi_ListViewID, $psi_File)
	$psi_SelectedItem=_GUICtrlListViewGetCurSel($psi_ListViewID)
	$psi_SelectedItem=$psi_SelectedItem+1
	Dim $psi_FileRW[1]
	_FileReadToArray($psi_File, $psi_FileRW)
	_ArrayDelete($psi_FileRW, $psi_SelectedItem)
	_FileWriteFromArray($psi_File, $psi_FileRW, 1)
	GUICtrlDelete($psi_ListViewItems[$psi_SelectedItem])
	_ArrayDelete($psi_ListViewItems, $psi_SelectedItem)
EndFunc ;==>psi_RemoveListItem()