;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~(Psibernetic Computing's X- AutoIt3 Special Edition)~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~(01/03/07 - 1/10/07)~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include <GUIConstants.au3>
#include <File.au3>
#include <Array.au3>
#Include <String.au3>
#Include <GuiListView.au3>
#include <FileEncryption.au3>
#include <xZipUDF.au3>
#Include <PsiberneticUDF.au3> 
#NoTrayIcon

;Initial Variables
$xHSpath=@ScriptDir & "\HSlog\logHSfiles.log" ;Path to the Entry Database
$xEncryptPath=@scriptDir &"\HSlog\PSIFR.log" ;Path to the first time run and password file
$xFirstRun=FileReadLine($xEncryptPath, 1) ;is it the first run?

If Not FileExists(@ScriptDir & '\XZip.dll') Then
	MsgBox(16,"Missing necessary file!", "You are missing the XZipDll, you may download the dll from: http://xstandard.com/printer-friendly.asp?id=C9891D8A-5390-44ED-BC60-2267ED6763A7")
	Exit
endif
__DOSStart('regsvr32 /s "' & @ScriptDir & '\XZip.dll' & '"')
Sleep(1000)
;This Code Executes on user's first run of the program, sets the password for encryption and decryption
If $xFirstRun<>1 then ;execute if first run
	$xEncryptPassword=InputBox("Password Set","Please set your password to encrypt your database","","*M") ;ask what to set the password as
	
	If @error=1 then exit
	
	$xSetEncryptedPass=_StringEncrypt(1,$xEncryptPassword,"PsiPhi",2) ;Encrypt it
	FileWriteLine($xEncryptPath, 1) ;Write on the first line 1 telling x-hide it has been ran before (set this to zero manually to change pass)
	FileWriteLine($xEncryptPath, $xSetEncryptedPass) ;Write the encrypted passwaord
	
	;Log Encryption
	$xDatabaseCrypt=_FileCountLines($xHSpath) ;See how many lines there are
	If $xDatabaseCrypt<>0 Then ; If there are any entries, do following:
		dim $ArrayToClearLog[1] ;make an array for clearing file
		$ArrayToClearLog[0]="" ;set the array's only element to nothing
		$xHS_Database=FileRead($xHSpath) ; read the log into $xHS_Database
		$xHS_Database_En=_StringEncrypt(1,$xHS_Database,$xDecryptPassword,2) ;Save the encrypted log into $xHS_Database_En
		_FileWriteFromArray ($xHSpath, $ArrayToClearLog) ;Clear the log
		FileWrite($xHSpath, $xHS_Database_En) ;Write the encrypted log back
	EndIf
EndIf


$xPasswordEncrypted=FileReadLine($xEncryptPath, 2)
$xPasswordDecrypted=_StringEncrypt(0,$xPasswordEncrypted,"PsiPhi",2)

$xDecryptPassword=InputBox("Password Required", "Please enter the password to decrypt your database", "","*M")

If @error=1 then exit
	
If $xDecryptPassword<>$xPasswordDecrypted Then
	msgbox(0,"ERROR","Incorrect Password, Good-Bye")
	Exit
Else
	;Log Decryption
	$xDatabaseCrypt=_FileCountLines($xHSpath) ;See how many lines there are
	If $xDatabaseCrypt<>0 Then ; If there are any entries, do following:
		dim $ArrayToClearLog[1] ;make an array for clearing file
		$ArrayToClearLog[0]="" ;set the array's only element to nothing
		$xHS_Database=FileRead($xHSpath) ; read the log into $xHS_Database
		$xHS_Database_De=_StringEncrypt(0,$xHS_Database,$xDecryptPassword,2) ;Save the decrypted log into $xHS_Database_De
		_FileWriteFromArray ($xHSpath, $ArrayToClearLog) ;Clear the log
		FileWrite($xHSpath, $xHS_Database_De) ;Write the Decrypted log back
	EndIf
EndIf


;Define GUI type and specifics
$xMainWin=GUICreate("Securacy (0.9.3) Beta", 300, 242)
	GUISetIcon ("Xau3.ico")
	GUISetBkColor(0x000000)

;Picture CTRLs
$xLogoPic=GUICtrlCreatePic(@ScriptDir & "\button\securacy.bmp", 63,0, 172, 63) ;$xLogoPic Construction
$xFilePic=GUICtrlCreatePic(@ScriptDir & "\button\file.bmp",-10,122,75,30) ;$xFilePic Construction
$xFolderPic=GUICtrlCreatePic(@ScriptDir & "\button\folder.bmp",215,122,75,30) ;$xFolderPic Construction
$xHide=GUICtrlCreatepic(@scriptDir & "\Button\secure.bmp", 2, 32, 59, 30) ;xHide Construction
$xBrowse=GUICtrlCreatepic(@scriptDir & "\Button\browse.bmp", 120, 68, 59, 30) ;xBrowse Construction
$xUnHide=GUICtrlCreatepic(@scriptDir & "\Button\unsecure.bmp", 239, 32, 59, 30) ;xUnHide Construction
	
;Input CTRLs
$xFilePath=GUICtrlCreateInput("",41,103,216,20) ;xFilePath Construction
	GUICtrlSetBkColor($xFilePath, 0x000000) ;xFilePath Background Color: 000000(Black)
	GUICtrlSetColor($xFilePath, 0x00FF00) ;xFilePath Font Color: 00FF00(lime)

;Slider CTRLs
$xBrowseType=GUICtrlCreateSlider(65,127,150) ;xBrowseType Construction
	GUICtrlSetLimit($xBrowseType,2,1)   ; change min/max value

;ListView CTRLs
$xHiddenListView=GUICtrlCreateListView ("File|Path",0,154,300,88,$LVS_NOSORTHEADER) ;xHiddenListView Construction
	GUICtrlSetBkColor($xHiddenListView, 0x000000) ;xHiddenListView Background Color: 000000(Black)
	GUICtrlSetColor($xHiddenListView, 0x00FF00) ;xHiddenListView Font Color: 00FF00(lime)
	_GUICtrlListViewSetColumnWidth ( $xHiddenListView, 0, 70 ) ;set "File" column width to 70
	_GUICtrlListViewSetColumnWidth ( $xHiddenListView, 1, 226 ) ;set "Path" column width to 226
;ListView Item CTRLs
psi_LoadList($xHSpath, $xHiddenListView) ;Call the xLoadList function exports control IDs to the array $xListItems[]

;GUI activate
GUISetState(@SW_SHOW)
;Program Event Checking loop
While 1
	$Event=GUIGetMsg()
	Select 
		case $Event=$GUI_EVENT_CLOSE
			ExitLoop
		case $Event=$xBrowse
			$xBrowseMethod=GUICtrlRead($xBrowseType)
			Select
				case $xBrowseMethod=1
					$xRetrievedPath=FileOpenDialog("Choose your file to hide/unhide...", "C:\", "All (*.*)", 1+2+4+8)
					ControlSetText("","",$xFilePath, $xRetrievedPath)
				case $xBrowseMethod=2
					$xRetrievedPath=FileSelectFolder("", "C:\" & @CommonFilesDir)
					ControlSetText("","",$xFilePath, $xRetrievedPath)
				EndSelect
				
		case $Event=$xHide ;If Hide is clicked execute following
			$xFile=ControlGetText ("","",$xFilePath) ;get the path returned by Browse
			Select
				case $xFile<>""
					$xFileCol=psi_PathManipulate($xFile, "F") ;retreive the file portion of the fullpath				
					$xPathCol=psi_PathManipulate($xFile, "P") ;retreive the path portion of the fullpath			
					$xFileAndPathCols=$xFileCol & "|" & $xPathCol ;format the path and filename as reurned by psi_PathManipulate
					Select 
						case $xFileCol<>"N/A"
							Dim $xFullPath[1]
							$xFullPath[0]=$xPathCol & $xFileCol
							$xZippedFilePath=$xFullPath[0] & ".zip"
							_ZipOpen($xZippedFilePath)
							_ZipPackGroup($xFullPath, False)
							_ZipClose()
							$xEncryptedFilePath=$xPathCol & "PsiE_" & $xFileCol & ".zip"
						case $xFileCol="N/A"
							Dim $xFullPathDir[1]
							$xFolderDir=psi_PathManipulate($xFile & ".", "F") ;retreive the final dir portion of the fullpath (added decimal to trick function into treating it as a file)
							$xFolderDir=StringLeft($xFolderDir,stringlen($xFolderDir)-1) ;get rid of the decimal
							$xPathFolder=psi_PathManipulate($xFile & ".", "P") ;retreive the path portion of the fullpath (added decimal to trick function to returning the path -1 directory)
							$xFullPathDir[0]=$xPathCol
							$xZippedFilePath=$xPathCol & ".zip"
							_ZipOpen($xZippedFilePath)
							_ZipPackGroup($xFullPathDir, False)
							_ZipClose()
							$xFolderDir="PsiE_" & $xFolderDir
							$xEncryptedFilePath=$xPathFolder & $xFolderDir & ".zip"
					EndSelect
					_PsiEncrypt($xZippedFilePath, $xEncryptedFilePath, $xDecryptPassword & "@1") ; IDEA Encrypt File
					While Not FileExists($xEncryptedFilePath)
						sleep(200)
					WEnd
					Select
						case $xFileCol<>"N/A"
							FileDelete($xFile)
						case $xFileCol="N/A"
							DirRemove($xFile,1)
					EndSelect
					FileDelete($xZippedFilePath)
					psi_Hide($xEncryptedFilePath, "hide") ;make "Superhidden" (Hidden System files)
					psi_AddListItem($xHSpath, $xFileAndPathCols, $xHiddenListView) ; add new file to the log and ListView
				Case $xFile=""
					MsgBox(0,"Incorrect Input","Please browse for a file or folder to secure first.")
			EndSelect
			ControlSetText("","",$xFilePath,"") ;empty the input boxes content
			
		case $Event=$xUnHide ;If UnHide is clicked execute following
			$xFile=ControlGetText ("","",$xFilePath)
			Select
				Case $xFile<>""
					$xFileName=Psi_PathManipulate($xFile & ".", "F")
					$xFileLoc=Psi_PathManipulate($xFile, "P")
					$xFileName=StringLeft($xFileName, stringlen($xFileName)-1)
					$xFolderPath=Psi_PathManipulate($xFile & ".", "P")
					Select
						case StringInStr($xFile, ".") <> 0
							$xEncryptedFilePath=$xFileLoc & "PsiE_" & $xFileName & ".zip"
							$xDecryptedZipFile=$xFileLoc & $xFileName & ".zip"
						case StringInStr($xFile, ".") = 0
							$xEncryptedFilePath=$xFolderPath & "PsiE_" & $xFileName & ".zip"
							$xDecryptedZipFile=$xFolderPath & $xFileName & ".zip"
					EndSelect
					_PsiDecrypt($xEncryptedFilePath, $xDecryptedZipFile, $xDecryptPassword & "@1")
					While Not FileExists($xDecryptedZipFile)
						sleep(200)
					WEnd
					_ZipOpen($xDecryptedZipFile)
					_ZipContents()
					Select
						Case $ZipContent[0]-1 = 1
							_ZipUnpack($xFileLoc)
						Case Else
							_ZipUnpack($xFile)
					EndSelect
					_ZipClose()
					FileDelete($xEncryptedFilePath)
					FileDelete($xDecryptedZipFile)
					psi_RemoveListItem($xHiddenListView, $xHSpath)
				case $xFile=""
					MsgBox(0,"Incorrect Input","Please select an item to Unsecure from below first.")
			EndSelect
			ControlSetText("","",$xFilePath,"")
			
 		case $Event=$GUI_EVENT_PRIMARYDOWN
			psi_DetectDblClick()
		case $Event=$xFilePic
			GUICtrlSetData($xBrowseType,1)
		case $Event=$xFolderPic
			GUICtrlSetData($xBrowseType, 2)
	EndSelect
wend


;ReEnccrypt Entry DataBase
$xDatabaseCrypt=_FileCountLines($xHSpath) ;See how many lines there are
If $xDatabaseCrypt<>0 Then ; If there is any entries, do following:
	dim $ArrayToClearLog[1] ;make an array for clearing file
	$ArrayToClearLog[0]="" ;set the array's only element to nothing
	$xHS_Database=FileRead($xHSpath) ; read the log into $xHS_Database
	$xHS_Database_En=_StringEncrypt(1,$xHS_Database,$xDecryptPassword,2) ;Save the encrypted log into $xHS_Database_En
	_FileWriteFromArray ($xHSpath, $ArrayToClearLog) ;Clear the log
	FileWrite($xHSpath, $xHS_Database_En) ;Write the encrypted log back
EndIf


;End Execution

__DOSStart('regsvr32 /s /u "' & $sDllLoc_UDFGlobal & '"') 
Sleep(200);needs a sec when unloaded silently.
exit


func psi_DetectDblClick()
	$psi_SelectedItemListView=_GUICtrlListViewGetCurSel($xHiddenListView)
	Select
		Case $psi_SelectedItemListView<>-1
			$psi_LonePath=_GUICtrlListViewGetItemText($xHiddenListView, $psi_SelectedItemListView,1)
			$psi_Filename=_GUICtrlListViewGetItemText($xHiddenListView, $psi_SelectedItemListView,0)
			If $psi_Filename<>"N/A" Then
				$psi_FullPath=$psi_LonePath & $psi_Filename
				GUICtrlSetData($xFilePath, $psi_FullPath)
			Else
				GUICtrlSetData($xFilePath, $psi_LonePath)
			EndIf
	EndSelect
EndFunc